require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_UCONTEXT_H)) {
    eval 'sub _SYS_UCONTEXT_H () {1;}' unless defined(&_SYS_UCONTEXT_H);
    require 'features.ph';
    require 'bits/types.ph';
    require 'bits/types/sigset_t.ph';
    require 'bits/types/stack_t.ph';
    if(defined(&__USE_MISC)) {
	eval 'sub __ctx {
	    my($fld) = @_;
    	    eval q($fld);
	}' unless defined(&__ctx);
    } else {
	eval 'sub __ctx {
	    my($fld) = @_;
    	    eval q( &__  $fld);
	}' unless defined(&__ctx);
    }
    eval 'sub __NGREG () {23;}' unless defined(&__NGREG);
    if(defined(&__USE_MISC)) {
	eval 'sub NGREG () { &__NGREG;}' unless defined(&NGREG);
    }
    if(defined(&__USE_GNU)) {
	eval("sub REG_R8 () { 0; }") unless defined(&REG_R8);
	eval("sub REG_R9 () { 1; }") unless defined(&REG_R9);
	eval("sub REG_R10 () { 2; }") unless defined(&REG_R10);
	eval("sub REG_R11 () { 3; }") unless defined(&REG_R11);
	eval("sub REG_R12 () { 4; }") unless defined(&REG_R12);
	eval("sub REG_R13 () { 5; }") unless defined(&REG_R13);
	eval("sub REG_R14 () { 6; }") unless defined(&REG_R14);
	eval("sub REG_R15 () { 7; }") unless defined(&REG_R15);
	eval("sub REG_RDI () { 8; }") unless defined(&REG_RDI);
	eval("sub REG_RSI () { 9; }") unless defined(&REG_RSI);
	eval("sub REG_RBP () { 10; }") unless defined(&REG_RBP);
	eval("sub REG_RSP () { 11; }") unless defined(&REG_RSP);
	eval("sub REG_RBX () { 12; }") unless defined(&REG_RBX);
	eval("sub REG_RDX () { 13; }") unless defined(&REG_RDX);
	eval("sub REG_RCX () { 14; }") unless defined(&REG_RCX);
	eval("sub REG_RAX () { 15; }") unless defined(&REG_RAX);
	eval("sub REG_RIP () { 16; }") unless defined(&REG_RIP);
	eval("sub REG_CS () { 17; }") unless defined(&REG_CS);
	eval("sub REG_RFL () { 18; }") unless defined(&REG_RFL);
	eval("sub REG_ERR () { 19; }") unless defined(&REG_ERR);
	eval("sub REG_TRAPNO () { 20; }") unless defined(&REG_TRAPNO);
	eval("sub REG_OLDMASK () { 21; }") unless defined(&REG_OLDMASK);
	eval("sub REG_CR2 () { 22; }") unless defined(&REG_CR2);
    }
    undef(&__ctx) if defined(&__ctx);
}
1;
